#include <bits/stdc++.h>

using namespace std;

int a[200005],p[200005],cnt[200005];
bool s[200005];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    for(int i=1;i<=n;i++)
        cin>>a[i];
    s[0]=0;
    s[1]=false; //nije obrnut
    for(int i=2;i<=n;i++)
    {
        if(a[i]<a[i-1])
            s[i]=true;
        else
            s[i]=false;
    }
    p[0]=0;
    for(int i=1;i<=n;i++)
    {
        p[i]=p[i-1];
        if(s[i])
            p[i]=i;
    }
    cnt[0]=0;
    if(s[1])
        cnt[1]=1;
    else
        cnt[1]=0;
    for(int i=2;i<=n;i++)
    {
        cnt[i]=cnt[i-1];
        if(s[i])
            cnt[i]++;
    }
    int q;
    cin>>q;
    while(q--)
    {
        int l,r;
        cin>>l>>r;
        if(cnt[r]-cnt[l-1]==0)
        {
            cout<<"DA"<<endl;
            continue;
        }
        if(cnt[r]-cnt[l-1]>=2)
        {
            cout<<"NE"<<endl;
            continue;
        }
        if(s[l] || s[l+1] || s[r])
        {
            cout<<"DA"<<endl;
            continue;
        }
        int ind=p[r];
        if(a[ind]>=a[ind-2] || a[ind+1]>=a[ind-1])
        {
            cout<<"DA"<<endl;
            continue;
        }
        cout<<"NE"<<endl;
    }
    return 0;
}